 	TITLE '<COM 1.2>'
;COM12/ASM - EDAS Source
;Assemble as COM/CMD  with EDAS
;Based on a program by appearing in "80 MICRO", 1/84
;
;08/23/83 -Original code by Ronald Balonis
;11/04/85 -LDOS 5.1.4 version by Jim LaSalle, K3OV
;11/28/85 -Fixed LDOS to M100 partial file transfer
;          problem. Jim LaSalle
;
;File transfer utility from the Lobo Max-80 or Model 3
;    to TRS-80 Model 100 using RS232 communication.
;
;
; RS232 COM STATS
;	XON/OFF on to send to Model 100 only
; Configure Max-80 from LDOS with:
;     SET *CM RS232M (B=9600,W=8,P=N,S=1,PORT=1)
; On Model 100 use SAVE or LOAD COM:88n1e
;
;To output a disk file 
;Type: COM O FILENAME
;
; To input a 100 file
; Type: COM I FILENAME
;
TRUE	EQU	-1
FALSE	EQU	0
TMOD3	EQU	TRUE		;Model 3 LDOS
TMOD1	EQU	FALSE		;Model 1 LDOS
	IF	TMOD1
HIMEM	EQU	404AH		;MSB of HIGH$
INBUF$	EQU	4318H
	ENDIF
	IF	TMOD3
HIMEM	EQU	4412H		;MSB of HIGH$
INBUF$	EQU	4225H
	ENDIF
XON	EQU	11H
XOFF	EQU	13H
CLS	EQU	01C9H		;Clear screen
@EXIT	EQU	402DH
@FSPEC	EQU	441CH
@INIT	EQU	4420H
@OPEN	EQU	4424H
@READ	EQU	4436H
@WRITE	EQU	4439H
@CLOSE	EQU	4428H
@GET	EQU	013H
@PUT	EQU	01BH
@DSP	EQU	33H
;
	ORG	5200H
	DATE			;EDAS date stamp
	DEFB	' '
	TIME			;EDAS time stamp
START
;--- Select <I>n or <O>
	LD	A,(HL)
	AND	5FH		;Convert to upper case
	CP	'I'
	JR	NZ,GIVE
	CALL	FILNAM
	JP	Z,GETCOM
GIVE
	CP	'O'
	JP	NZ,ERCMD
	CALL	FILNAM
	JP	NZ,ERCMD
;--- PUT THE DISK FILE IN STORAGE
GETDSK
	LD	DE,FCB
	LD	BC,000H
	PUSH	BC
	LD	HL,BUFFER
	CALL	@OPEN
	JP	NZ,EROPEN
	LD	DE,STORAG
	POP	BC
READLP	PUSH	BC		;Save byte count
	PUSH	DE		;Save storage location
	LD	DE,FCB
	CALL	@READ
	CP	1CH
	JR	Z,RCLOSE
	CP	1DH
	JR	Z,RCLOSE
	OR	A
	JP	NZ,ERREAD
	POP	DE
	LD	HL,BUFFER
	LD	BC,256
	LDIR			;Move I/O bufr to STORAG
	POP	BC		;Restore byte count
	INC	C		;Increment byte count
CKSIZE
	LD	A,(HIMEM)
	CP	D
	JP	C,TOOBIG
	JR	READLP
RCLOSE
	LD	DE,FCB
;---- PUT FILE LENGTH IN BC
	LD	A,(FCB+12)	;Sector with EOF marker.
;	INC	A		;This may need adjusted
				;for another DOS.
	LD	B,A
	LD	A,(FCB+8)	;End-of-file byte offset
	CP	000H		;Marker on sector boundary?
	JP	NZ,NOBOUND	;JP if not on boundary
	INC	B		;Adjust B for extra sector
NOBOUND
	LD	C,A
	CALL	@CLOSE
	JP	NZ,ERREAD
;---- SEND FILE TO RS232 COM PORT
PUTCOM
	PUSH	BC
	LD	DE,DCB		;Point to *CM DCB
;	Not necessary to point HL at I/O buffer
;	for devices with @OPEN.
	LD	B,0		;LRL or *CM (256 bytes)
	CALL	@OPEN
	JP	NZ,BADEV	;Can't open *CM device
	CALL	READY
	LD	HL,STORAG	;Restore RAM storage pointer
	POP	BC
;
COMOUT
	CALL	RSIN		;Get a byte from *CM
	CP	XOFF		;Are we waiting?
	JR	NZ,COMO		;Jump if XON
XXON	CALL	RSIN
	CP	XON
	JR	NZ,XXON
COMO	LD	A,(HL)		;Get a byte to send
	CALL	RSOUT		;Send it out RS232
	INC	HL		;Point to next character
	DEC	BC
	LD	A,C
	CP	0		;Last byte sent?
	JR	NZ,COMOUT	;No - send another else
	LD	A,B		;  see if another
	CP	1		;  256 bytes to send.
	JR	NZ,COMOUT
	LD	A,01AH		;Send EOF (^Z)
	CALL	RSOUT
	JP	@EXIT
;---- GETFILE FROM RS232 COM PORT
GETCOM
	LD	DE,DCB		;Point to *CM DCB
;	Not necessary to point HL at I/O buffer
;	for devices with @OPEN.
	LD	B,0		;Use LRL 0 for *CM device
	CALL	@OPEN
	JP	NZ,BADEV	;Can't open *CM
;
	CALL	READY
	LD	BC,0000H	;Init byte counter.
	LD	HL,STORAG	;Point to storage buffer.
COMIN	CALL	RSIN		;Get a byte from RS232.
	JR	Z,COMIN
DATAIN	CP	0AH
	JR	Z,COMIN
	CP	01AH		;Model 100 done sending?
	JR	Z,EOF
	LD	(HL),A
	INC	HL
	INC	BC
	JR	COMIN
EOF
	INC	B
	PUSH	BC
;---- PUT THE FILE ON THE DISK
WDISK	LD	DE,FCB
	LD	HL,BUFFER
	LD	BC,000H
	CALL	@INIT
	JP	NZ,ERWRIT
	LD	HL,STORAG
	POP	BC
WRITLP	PUSH	BC
	LD	DE,BUFFER
	LD	BC,256
	LDIR
	POP	BC
	PUSH	BC
	PUSH	HL
	LD	HL,BUFFER
	LD	DE,FCB
	CALL	@WRITE
	OR	A
	JP	NZ,ERWRIT
	POP	HL
	POP	BC
	DEC	B
	LD	A,B
	CP	255
	JP	NZ,WRITLP
WCLOSE	LD	DE,FCB
	IF	TMOD3
	LD	A,(FCB+12)
	DEC	A
	LD	(FCB+12),A
	ENDIF
	LD	A,C
	LD	(FCB+8),A
	CALL	@CLOSE
	JP	NZ,ERWRIT
	JP	@EXIT
;---- DISPLAY MESSAGES
READY	LD	HL,RDY
DSPLY	LD	A,(HL)
	OR	A
	RET	Z
	CALL	@DSP
	INC	HL
	JR	DSPLY
;
ERCMD	LD	HL,ERR0
	JR	DISPLY
EROPEN	LD	HL,ERR1
	JR	DISPLY
BADEV	LD	DE,FCB
	CALL	@CLOSE
	LD	HL,ERR4
	JR	DISPLY
ERREAD	LD	DE,FCB
	CALL	@CLOSE
	LD	HL,ERR2
	JR	DISPLY
ERWRIT	LD	DE,FCB
	CALL	@CLOSE
	LD	HL,ERR3
	JR	DISPLY
TOOBIG	LD	DE,FCB
	CALL	@CLOSE
	LD	HL,TOBIG
DISPLY	LD	A,(HL)
	OR	A
	JP	Z,@EXIT
	CALL	@DSP
	INC	HL
	JR	DISPLY
;
ERR0	DEFM	'     '
	DEFM	'* COMMAND LINE ERROR *',0DH,0DH
	DEFM	'           %%%%%% COM v1.2,  -11/28/85-   K3OV %%%%%%',0DH
	DEFM	'       '
	IF TMOD1
	DEFM	'TRS-80 Mod1'
	ENDIF
	IF	TMOD3
	DEFM	'Lobo Max-80'
	ENDIF
	DEFM	'/TRS-80 Model 100 File Transfer Utility',0DH
	DEFM	'===============================================================',0DH
	DEFM	'LDOS:  COM I filename   inputs  text file '
	DEFM	'from Model 100',0DH
	DEFM	'       COM O filename   outputs text file '
	DEFM	' to  Model 100',0DH
	DEFM	'---------------------------------------------------------------',0DH
	DEFM	'Model 100: SAVE COM:88n1e   outputs a TEXT file to LDOS',0DH
	DEFM	'           LOAD COM:88n1e   inputs  TEXT file from LDOS',0DH
	DEFB	0DH,0DH,0
ERR1	DEFM	'     '
	DEFM	'* FILE NOT FOUND *'
	DEFB	0
ERR2	DEFM	'     '
	DEFM	'* SOURCE ERROR *'
	DEFB	0
ERR3	DEFM	'     '
	DEFM	'* DESTINATION ERROR *'
	DEFB	0
ERR4	DEFM	'      '
	DEFM	'* CAN',27H,'T OPEN COMMUNICATIONS DEVICE *',0DH
	DEFM	'Type: SET *CM RS232M (B=9600,W=8,P=N,S=1,PORT=1)',0DH
	DEFB	0
TOBIG	DEFM	'     '
	DEFM	'* FILE TOO BIG *'
	DEFB	0
RDY
	DEFM	'     '
	DEFM	'* READY *'
	DEFB	0
;
;--- THE RS232 COM PORT
CONTRL	EQU	37E7H		;Max-80 Status Port B
DATA	EQU	37E6H		;Max-80 Data Port B
				;Max-80 Baud B 37D4H
;
RSOUT
	LD	DE,DCB
	CALL	@PUT
	RET
;
RSIN
	LD	DE,DCB		;Point to *CM DCB
	CALL	@GET
	RET
;
FILNAM
	INC	HL
	LD	A,(HL)
	CP	' '
	RET	NZ
	INC	HL		;First char of file name
	PUSH	HL		;Save start of file name
	LD	DE,FCB		;Point to FCB
	CALL	@FSPEC		;Place upper case file
				; name in FCB.
	POP	HL		;Restore start of name
	RET	;END OF FILNAME
;
DCB	DEFM	'*CM',0DH	;Device name and 32 byte
	DEFS	28		;  DCB for RS232 *CM device
CMBUFR	DEFS	256		;I/O buffer for *CM
;
FCB	DEFS	32
BUFFER	DEFS	256
STORAG	EQU	$
	END	START
;end of source

